Leetcode每日刷题之 1089. 复写零(C++)

1. 题目解析

由题目可知,我们需要将给定数组中的所有零复写一遍,并且保证不能超出数组长度,还不可以开辟新的数组,要在原数组的位置直接操作

2. 算法原理

1. 由题目我们可以将问题简化为找出最终复写完成数组的最后一个元素,然后从该元素由后 向前在原数组依次复写遇到的零元素即可

2. 所以我们首先的目标就是找出复写完成后的数组最后的一个元素是什么,那么我们可以使 用双指针的方法,即一个为快指针一个为慢指针, cur 从头开始作为慢指针向后遍历, dest 作为快指针由 - 1 位置开始向后遍历,当 cur 指针遇见非零元素则两个指针都向后移 一步,如果 cur 指针遇见了零元素,那么就将 cur 元素向后移一步,将 dest 指针向后移 两步,直到 dest 指向数组的末尾,那么这时的 cur 指针指向的元素就是复写后的数组的 最后一个元素

3. 当然需要注意不可以越,界访问,即当 dest 指针指向了数组末尾的下一个位置,这时就 不能直接对 dest 指针指向的区域操作赋值,所以我们可以直接将数组末尾元素赋值为0, 然后根据 cur 指针当前指向的元素进行 dest 指针的移动即可

cpp 复制代码
class Solution 
{
public:
    void duplicateZeros(vector<int>& arr) 
    {
        int cur = 0;
        int dest = -1;
        int n = arr.size();
        //1. 找到最终数组的最后一个元素
        while(cur < n)
        {
            if(arr[cur])
            {
                dest++;
            }
            else
            {
                dest += 2;
            }
            if(dest >= n - 1)
            {
                break;
            }
            cur++;
        }

        //2. 处理越界情况
        if(dest == n)
        {
            arr[n - 1] = 0;
            cur--;
            dest -= 2;
        }

        //3.复写零
        while(cur >= 0)
        {
            if(arr[cur])
            {
                arr[dest--] = arr[cur--];
            }
            else
            {
                arr[dest--] = 0;
                arr[dest--] = 0;
                cur--;
            }
        }
    }
};

3. 代码实现

相关推荐
黄金龙PLUS17 分钟前
5个1024比特大状态置换算法的设计与分析
算法·网络安全·密码学·哈希算法·同态加密
心中有你021427 分钟前
C语言埃氏筛法(素数筛选)
c语言·数据结构·算法
Omics Pro2 小时前
Cell封面|衰老生物学开源AI工具包
数据库·人工智能·算法·机器学习·自然语言处理
UIU1144 小时前
递归算法与汉诺塔
c++·学习·算法·c#·递归
Fruit_Caller4 小时前
static
开发语言·c++
用户979984807189 小时前
200 行代码写一个能跑的 AI Agent:不依赖任何框架,只靠 tool-calling 原理
算法
threerocks9 小时前
【Muse实战】X 流量作战室搭建保姆级教程 - 拥有你自己的运营团队
算法
GreenTea9 小时前
深度拆解 ScienceBuddy:如何用“双层递归自进化”构建高可靠科研 Agent Harness
前端·后端·算法
花椒技术9 小时前
2.46 秒生成 5 秒视频:拆解 H3 Max 的模型、推理栈与硬件协同
算法·音视频开发·视频编码
vivo互联网技术10 小时前
ART:妆容迁移框架,重新定义高保真妆容迁移 | ECCV 2026
人工智能·算法·图像识别